@echo off

REM ######################################################## 
REM # Script to archive file by Kai Zhang
REM # distributed under GNU General Public License
REM ######################################################## 

set CUR_FILE=%1
set ARCHIVE_PATH=%2

if #%CUR_FILE%# == ## goto PRINT_HELP;
if not exist %CUR_FILE% (
  echo.File not exist: %CUR_FILE%
  goto END_OF_FILE
)

for %%i in (%CUR_FILE%) do (
  set FILE_NAME=%%~ni
  set FILE_EXT=%%~xi
  set FILE_PATH=%%~dpi
)

if #%ARCHIVE_PATH%# == ## (
    set ARCHIVE_PATH=%FILE_PATH%archive
)

For /f "tokens=1-4 delims=/ " %%a in ("%date%") do (set MY_DATE=%%c_%%a_%%b_%%d)
IF "%time:~0,1%" LSS "1" (
  SET MY_TIME=0%time:~1,1%_%time:~3,2%_%time:~6,2%
) ELSE (
  SET MY_TIME=%time:~0,2%_%time:~3,2%_%time:~6,2%
)

set TARGET_FILE=%FILE_NAME%_%MY_DATE%_%MY_TIME%%FILE_EXT%
set TARGET_DIR=%ARCHIVE_PATH%\%MY_DATE%

if not exist %TARGET_DIR% mkdir %TARGET_DIR%
echo copy /Y %CUR_FILE% %TARGET_DIR%\%TARGET_FILE%
copy /Y %CUR_FILE% %TARGET_DIR%\%TARGET_FILE%
goto END_OF_FILE

:PRINT_HELP
echo.usage:
echo.   archiveFile fileName [archiveTargetDir]
echo.
echo.If the archiveTargetDir is not specified, the file will be archived into "archive" directory. Note that the srript doesn't support wildcard characters.
goto END_OF_FILE

:END_OF_FILE
@echo on

